![header](https://i.ibb.co/4YFZbBm/header.png)
![illustrator-scripts](https://i.ibb.co/Pm60cLC/cover.gif)

[![Behance](https://img.shields.io/badge/Behance-%40creold-0055FF.svg)](https://behance.net/creold) [![Instagram](https://img.shields.io/badge/Instagram-%40serg_osokin-8034B2.svg)](https://www.instagram.com/serg_osokin/) [![Yotube](https://img.shields.io/badge/-YouTube%20Channel-FF0000.svg)](https://www.youtube.com/c/SergOsokinArt/videos)

*Instructions in other languages: [English](README.md), [Русский](README.ru.md)*

# 👨‍💻 Hi
This is a collection of JSX scripts for Adobe Illustrator. All scripts created by me, sometimes used part of the code of other authors.  

The descriptions for each file can be found in the file's header text. Test environment: Illustrator CS6, CC 2021 (Windows), CC 2018-2021 (Mac OS).   

### 📜 Alphabetical list of scripts
* [ArtboardsRotateWithObjects.jsx]   
* [ConvertToGradient.jsx]   
* [DuplicateArtboardsLight.jsx] `(upd, 01.04.2021)`  
* [Export-selection-as-AI.jsx]   
* [ExtUngroup.jsx] `(upd, 25.11.2019)`   
* [FileVersionInformer.jsx]   
* [GradientToFlat.jsx] `(new, 20.04.2021)`  
* [InlineSVGToAI.jsx]   
* [NamedItemsFinder.jsx] `(new, 11.04.2021)`  
* [PointsMoveRandom.jsx] `(upd, 20.03.2021)`  
* [RandomScribble.jsx] `(new, 26.07.2021)`
* [RenameItems.jsx] `(upd, 20.03.2021)`
* [Rescale.jsx] `(upd, 24.03.2021)`
* [ResizeToSize.jsx] `(upd, 22.03.2021)`
* [SelectOnlyPoints.jsx] `(upd, 14.11.2020)`  
* [SelectPointsByType.jsx] `(upd, 20.03.2021)`   
* [SplitPath.jsx] `(upd, 30.08.2020)`    
* [StrokeColorFromFill.jsx] `(upd, 30.03.2021)`   
* [TrimMasks.jsx] `(upd, 30.03.2021)`
* [Zoom-and-center.jsx] `(upd, 20.03.2021)`

[ArtboardsRotateWithObjects.jsx]: https://github.com/creold/illustrator-scripts#artboardsrotatewithobjects-12
[ConvertToGradient.jsx]: https://github.com/creold/illustrator-scripts#converttogradient
[DuplicateArtboardsLight.jsx]: https://github.com/creold/illustrator-scripts#duplicateartboardslight
[Export-selection-as-AI.jsx]: https://github.com/creold/illustrator-scripts#export-selection-as-ai 
[ExtUngroup.jsx]: https://github.com/creold/illustrator-scripts#extungroup-v12
[FileVersionInformer.jsx]: https://github.com/creold/illustrator-scripts#fileversioninformer
[GradientToFlat.jsx]: https://github.com/creold/illustrator-scripts#gradienttoflat
[InlineSVGToAI.jsx]: https://github.com/creold/illustrator-scripts#inlinesvgtoai
[NamedItemsFinder.jsx]: https://github.com/creold/illustrator-scripts#named-items-finder
[PointsMoveRandom.jsx]: https://github.com/creold/illustrator-scripts#points-move-random
[RandomScribble.jsx]: https://github.com/creold/illustrator-scripts#randomscribble
[RenameItems.jsx]: https://github.com/creold/illustrator-scripts#renameitems
[Rescale.jsx]: https://github.com/creold/illustrator-scripts#rescale
[ResizeToSize.jsx]: https://github.com/creold/illustrator-scripts#resizetosize
[SelectOnlyPoints.jsx]: https://github.com/creold/illustrator-scripts#selectonlypoints
[SelectPointsByType.jsx]: https://github.com/creold/illustrator-scripts#selectpointsbytype
[SplitPath.jsx]: https://github.com/creold/illustrator-scripts#splitpath
[StrokeColorFromFill.jsx]: https://github.com/creold/illustrator-scripts#strokecolorfromfill
[TrimMasks.jsx]: https://github.com/creold/illustrator-scripts#trimmasks
[Zoom-and-center.jsx]: https://github.com/creold/illustrator-scripts#zoom-and-center

### ▶️ How to run scripts

#### Variant 1 — Install 

1. [Download archive] and unzip. All scripts are in the folder `jsx`
2. Place `<script_name>.jsx` in the Illustrator Scripts folder:
	- OS X: `/Applications/Adobe Illustrator [vers.]/Presets.localized/en_GB/Scripts`
	- Windows (32 bit): `C:\Program Files (x86)\Adobe\Adobe Illustrator [vers.]\Presets\en_GB\Scripts\`
	- Windows (64 bit): `C:\Program Files\Adobe\Adobe Illustrator [vers.] (64 Bit)\Presets\en_GB\Scripts\`
	- RU lang: `C:\Program Files\Adobe\Adobe Illustrator [версия]\Стили\ru_RU\Сценарии\`
3. Restart Illustrator

[Download archive]: http://bit.ly/2M0j95N 

#### Variant 2 — Drag & Drop
Drag and drop the script file (JS or JSX) into Adobe Illustrator Window

#### Variant 3 — Use extension
I recommend the [Scripshon Trees] or [LAScripts] panel. In it you can specify which folder your script files are stored in.

[Scripshon Trees]: https://exchange.adobe.com/creativecloud.details.15873.scripshon-trees.html
[LAScripts]: https://ladygin.pro/products/lascripts/

### 💸 Donate (optional)
If you find this script helpful, you can buy me a coffee ☕️ via [PayPal], [ЮMoney] or [Donatty] 🙂  

[PayPal]: https://paypal.me/osokin/2usd
[ЮMoney]: https://yoomoney.ru/to/410011149615582
[Donatty]: https://donatty.com/sergosokin
<a href="https://paypal.me/osokin/3usd">
  <img width="160" height="49" src="https://i.ibb.co/LkgNvzG/paypal-badge.gif" >
</a>

<a href="https://yoomoney.ru/to/410011149615582">
  <img width="160" height="49" src="https://i.ibb.co/6s5DFCd/yoomoney-badge.gif" >
</a>

<a href="https://donatty.com/sergosokin">
  <img width="160" height="49" src="https://i.ibb.co/tcwzLkB/donatty-badge.gif" >
</a>

## ArtboardsRotateWithObjects 1.2

Script to rotate 90 degrees an document artboards with all the objects on it.   
*Author: [Alexander Ladygin](http://ladygin.pro/). UI: Sergey Osokin.*

### Usage

1. Open your file
2. Run script `File → Scripts → ArtboardsRotateWithObjects`
3. Select the options in the dialog box

![ArtboardsRotateWithObjects](https://i.ibb.co/YtV4nc6/demo-Artboards-Rotate-With-Objects.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## ConvertToGradient

Convert a flat process color into a matching gradient.   
What's new: The script now works with the RGB and CMYK document profile, Spot & Gray colors. Processes compound paths and groups of items.   
*Based on original script by [Saurabh Sharma](https://tutsplus.com/authors/saurabh-sharma), 2010.*   

### Usage

1. Select objects
2. Run script `File → Scripts → ConvertToGradient`
3. Enter a numeric values in input fields

![ConvertToGradient](https://i.ibb.co/44tG9JP/demo-Convert-To-Gradient.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## DuplicateArtboardsLight

Script for copying the selected Artboard with his artwork. The Pro version with more options is available at [Gumroad](https://gumroad.com/sergosokin)   

<a href="https://youtu.be/qDH1YRaYMYk">
  <img width="122" height="47" src="https://i.ibb.co/fqdwXL6/youtube-badge.png">
</a>

### Usage

1. Run script `File → Scripts → DuplicateArtboardsLight `
2. Enter a numeric values in input fields

![ConvertToGradient](https://i.ibb.co/rF92HpV/demo-Duplicate-Artboards-Light.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 


## Export selection as AI
Exports all selected objects to AI files.    
*Based on Layers to SVG 0.1 by Anton Ball.*

### Usage

1. Select objects
2. Run script `File → Scripts → Export-selection-as-AI`
3. Select options in dialog box
 

![Export-selection-as-AI](https://i.ibb.co/CPSRxq8/demo-Export-selection-as-AI.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## ExtUngroup v.1.2
This script is сan be easily custom ungrouping to all group items & releasing clipping masks in the document.   
*Based on original script by Jiwoong Song & modification by [John Wundes](http://www.wundes.com/).*

### Usage

1. Select object(s) to ungroup or deselect all
2. Run script `File → Scripts → ExtUngroup`
3. Select options in dialog box
 

![Zoom-And-Center](https://i.ibb.co/QngnpZL/demo-Ext-Ungroup.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## FileVersionInformer

Script for collecting information about the program version of .ai & .eps files in selected folder & subfolder.   
*Notice: on large files it works slowly, just wait.*

### Usage

1. Run script `File → Scripts → FileVersionInformer`
2. Choose folder with .ai or .eps files
3. Wait for the completion message
4. Look "FileVersionInformer.txt" in source folder
 

![FileVersionInformer](https://i.ibb.co/mz94Tn0/demo-File-Version-Informer.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## GradientToFlat

Convert a gradient to an interpolated solid color.

### Usage

1. Run script `File → Scripts → GradientToFlat`
2. Choose options. Shortcuts <kbd>F</kbd>, <kbd>S</kbd>
3. Press button "OK"

![GradientToFlat](https://i.ibb.co/yn1j852/demo-Gradient-To-Flat.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## InlineSVGToAI

The script inserts the SVG code as an object from the clipboard into the Adobe Illustrator CC 2014+. Adobe Illustrator CC 2018 v.22.1 (march, 2018) can insert SVG graphics without a script.   
*Author: [Alexander Ladygin](http://ladygin.pro/). Code refactoring: Sergey Osokin.*

### Usage

1. Run script `File → Scripts → InlineSVGToAI`
2. Paste your svg code in textarea
3. Press button "Paste"

![InlineSVGToAI](https://i.ibb.co/xSzT8z4/demo-Inline-SVGTo-AI.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## Named Items Finder

Search items in the document by name and zoom to them contents. Inspired by Photoshop CC 2020 features.   

<a href="https://youtu.be/30AwGPf_2Wk">
  <img width="122" height="47" src="https://i.ibb.co/fqdwXL6/youtube-badge.png">
</a>

### Usage

1. Run script `File → Scripts → NamedItemsFinder`
2. Enter the name of the item
3. Choose options
4. Click on a match from the list to zoom

![NamedItemsFinder](https://i.ibb.co/QDVtnXP/demo-Named-Items-Finder.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## Points Move Random

The script moves randomly in numeric ranges horizontally and vertically selected points or all points on objects.   

<a href="https://youtu.be/9wVTDWUAEmE">
  <img width="122" height="47" src="https://i.ibb.co/fqdwXL6/youtube-badge.png">
</a>

### Usage

1. Run script `File → Scripts → PointsMoveRandom`
2. Enter number values
3. Choose options
4. Press button "Apply" or <kbd>Alt</kbd>+<kbd>A</kbd>

![PointsMoveRandom](https://i.ibb.co/9ZsRQJk/demo-Points-Move-Random.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## RandomScribble

Creates random paths with a specified number of points. These can be random straight lines from 2 points or complex shapes that imitate scribbles. The points do not go beyond the bounds of the active artboard. If many shapes are first selected in the document, the script will generate individual paths with points into their bounding box.

### Usage

1. Run script `File → Scripts → RandomScribble`
2. Choose options
3. To generate variations, click `Randomize`

![RandomScribble](https://i.ibb.co/b6FftPk/Random-Scribble.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a>

## RenameItems

Script to batch rename selected items with many options or simple rename one selected item / active layer.      

### Usage

1. Run script `File → Scripts → RenameItems`
2. Enter name
3. Choose options

![Rescale](https://i.ibb.co/Gkcqt8D/demo-Rename-Items.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## Rescale

Automatic scaling of objects to the desired size. If you draw a line on top with the length or height of the desired object, 'Old Size' will be filled automatically. Units associated with "Document Setup".      

### Usage

1. Run script `File → Scripts → Rescale`
2. Enter numeric values
3. Press button "OK" 

![Rescale](https://i.ibb.co/gDj142f/demo-Rescale.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## ResizeToSize

Adobe Illustrator has a Transform panel, but you cannot use it to transform several selected objects to a specified value. It also has problems with the accuracy of the result. The script can transform selected objects with 100% accuracy, depending on the selected side: width, height or automatically the larger side. Units associated with "Document Setup". Quick access with <kbd>Alt</kbd> + underlined key or digit.      

<a href="https://youtu.be/PN3dAf6rac8">
  <img width="122" height="47" src="https://i.ibb.co/fqdwXL6/youtube-badge.png">
</a>

### Usage

1. Run script `File → Scripts → ResizeToSize`
2. Enter numeric values
3. Choose options
4. Press button "OK" 

![ResizeToSize](https://i.ibb.co/FxPGDM2/demo-Resize-To-Size.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## SelectOnlyPoints

After using the Lasso tool or Direct Selection Tool, both Points and Path segments are selected. 

### Usage

1. Select points on paths with Direct Selection Tool key: <kbd>A</kbd> or Lasso tool key: <kbd>Q</kbd>
2. Run script `File → Scripts → SelectOnlyPoints`
 

![SelectOnlyPoints](https://i.ibb.co/NF7bbpQ/demo-Select-Only-Points.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## SelectPointsByType

Selects points on the selected paths according to their type. Does the thing that even Astute Graphics plugins can't do :)   
Select `View → Hide Bounding Box` to see active points in real time.   

<a href="https://youtu.be/pjHmBDLIWbw">
  <img width="122" height="47" src="https://i.ibb.co/fqdwXL6/youtube-badge.png">
</a>

### Usage

1. Select paths with Direct Selection Tool key: <kbd>A</kbd> or Group Selection Tool
2. Run script `File → Scripts → SelectPointsByType`
3. Click the button or use keyboard shortcuts:

* Bezier <kbd>Alt</kbd>+<kbd>1</kbd>
* Flush <kbd>Alt</kbd>+<kbd>2</kbd>
* Corner <kbd>Alt</kbd>+<kbd>3</kbd>
* Broken <kbd>Alt</kbd>+<kbd>4</kbd>
* Flat <kbd>Alt</kbd>+<kbd>5</kbd>

![SelectPointsType](https://i.ibb.co/8X0SFNc/demo-Select-Points-By-Type.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## SplitPath

Powerfull script for subtract shapes from paths. Pathfinder panel in Adobe Illustrator does not do it.   

<a href="https://youtu.be/1_vUUFkTwxk">
  <img width="122" height="47" src="https://i.ibb.co/fqdwXL6/youtube-badge.png">
</a>

### Usage

1. Place the closed filled shape top
2. Select shape and line
3. Run script `File → Scripts → SplitPath `
4. Select cut method in dialog box
 

![SplitPath](https://i.ibb.co/55fmqgY/demo-Split-Path.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## StrokeColorFromFill

Setting the Stroke color of object based on an his solid or gradient fill. The option to automatically add an stroke is not available for Mac OS users with an Illustrator older than CC 2020.   

### Usage

1. Select object(s)
3. Run script `File → Scripts → StrokeColorFromFill `
4. Enter color shift value
 

![SplitPath](https://i.ibb.co/8dtK1V3/demo-Stroke-Color-From-Fill.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## TrimMasks

Automatic trimming of all clipping groups in selection or a document using `Pathfinder > Crop`.   
If you want to save the filled mask after trimming, open the script file in a text editor and change `SAVE_FILLED_CLIPMASK = false;` value to `true`.

<a href="https://youtu.be/liui0ZUAN50">
  <img width="122" height="47" src="https://i.ibb.co/fqdwXL6/youtube-badge.png">
</a>

### Usage

1. Select object(s) or deselect all
2. Run script `File → Scripts → TrimMasks `

![TrimMasks](https://i.ibb.co/prkQGyt/demo-Trim-Masks.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## Zoom and center

Zooms active view to selection or to all object(s) in a document.   
*Based on original script by [John Wundes](http://www.wundes.com/).*

### Usage

1. Select object(s) to zoom or deselect all
2. Run script `File → Scripts → Zoom-and-center`
3. If nothing is selected, you will see a dialog with options
 

![Zoom-And-Center](https://i.ibb.co/4Kqx7J1/demo-Zoom-And-Center.gif) 

<a href="http://bit.ly/2M0j95N">
  <img width="160" height="49" src="https://i.ibb.co/CVHgrFk/download-en.png">
</a> 

## 🗣 Testimonials
* Sergey, these scripts of yours are great — Terry Foxx   
* Wow. I just installed and successfully tested. Outstanding work!!! — Zak Lay
* Tried your script to export selected objects to separate Ai, works smartly — Dmitry
* I looked at your post. Useful scripts! — Askhat Gilyakhov
* Thank you for such wonderful scripts — Oleg Zybailov

#### Don't forget sharing link with a friend 🙂 

## 🧩 Other scripts
You can view all the scripts that are not included in this collection in [another repository](https://github.com/creold/adobe-scripts)

## 🤝 Contribute

Found a bug? Please [submit a new issues](https://github.com/creold/illustrator-scripts/issues) on GitHub.

### Contact
Email <hi@sergosokin.ru>  
Telegram [@sergosokin](https://t.me/sergosokin)

### 📝 License

All scripts is licensed under the MIT licence.  
See the included LICENSE file for more details.